with import <nixpkgs> { };

stdenv.mkDerivation rec {
  pname = "spark_fs_drivers";
  version = "0.0.0";

  src = ./.;

  nativeBuildInputs = [
    gnat
    gprbuild
    spark2014
    z3
    cppcheck
  ];

  gprFile = "default.gpr";

  dontConfigure = true;

  buildPhase = ''
    runHook preBuild

    gprbuild -P ${gprFile}
    gnatprove -P ${gprFile} --prover=z3

    runHook postBuild
  '';

  installPhase = ''
    runHook preInstall

    mkdir -p $out/bin
    gprinstall --prefix=$out ${gprFile} \
      --no-project \
      --no-manifest \
      --mode=usage
    
    runHook postInstall
  '';
}
